*** VISG version changes.

--- 0.951 (April 17 2008)

+ fixed "clone.vsg".
+ support prefix sign-operators "-" and "+" in eval command.

--- 0.95 (March 30 2008)

+ added: Welcome Window.
+ modified: About DialogBox.
+ Ctrl+M activates main window.
+ fixed a bug with nested loops.
+ added new variables: c.tab_x, c.tab_y: coordinates of the control which are related to the origin of tab.
+ fixed a little eval bug with brackets.
+ added: jscript generator.
+ fixed white backcolor of the text in the tooltips.
+ now Visg uses UNICODE characters internally instead of ANSI.
+ used the windows APIs instead of stdio.h, string.h, stdlib.h.
+ used new file functions (smart wrapper for reading unicode and ansi files with autodetecting the file format).
+ now Visg is able to generate files in two formats: ansi and unicode (see Settings).
+ support of dialog length units (dlu). for example: %set c.x "5 dlu"
+ added variables: w.x.dlu, w.y.dlu, c.x.dlu, c.y.dlu, w.width.dlu, w.height.dlu, c.height.dlu, c.width.dlu, i.width.dlu.
+ now project files use DLU for x, y, width, height.
+ added: several hints in the main menu ( it looks like "[ hint ]" ).
+ up to 8 recent projects.
+ removed lng_tr2.vsg ( Russian translit #2 ).
+ fixed: "list clear" operation.

--- 0.94 (October 28 2007)

+ added list operations: %list clear <var1>..<varN>, %list add <dest> <item1>...<item2>,
  %list length <dest> <var>, %list nth <dest> <src> <index>
+ fixed: getting the program path for plugins and other data.
+ added: now you can run Visg with a filename of the project you want to open.
+ group generators in the menu.
+ fixed bug with saving tabcontrol which has nonfirst selected item.
+ added visual basic generator + fasm generator.

--- 0.932 (October 09 2007)

+ Fixed Win2k problem with LVM_GETCOLUMNWIDTH (visg could not work with grids in win2k).
+ The project opening is faster now.
+ Removed color dots from the big icons.
+ Removed "show all windows" button. It's not needed.
+ Fixed the code generation when a window is empty.

--- 0.93 (October 08 2007)

+ in the property window: do not redraw the assigned control if its style isn't changed.
+ now the key navigation works faster in the property window.
+ draw the frame around the whole control window, not only its client area.
+ Ctrl+I activates the tool window, if it exists.
+ Ctrl+P activates the property window, if it exists.
+ Modified several captions of menu items.
+ Multiline tooltips.
+ Added some extra error processing.
+ Fixed some memory leaks.
+ Show little screenshots in tooltips (optional).
+ Show big images in the tool window (optional).
+ The tool window can be resized.
+ Show current project in the main window.
+ Added "New Project" menu item.
+ Added list of recent projects in the File menu.
+ VISG Script Engine is enhanced (fast search of variables, the file cache).
+ new cmd: %eval <dest-var> <expression> : evaluate a math experssion.
+ new cmd: %uppercase <var-name> and %lowercase <var-name>
+ now the commands "%style <st> <val>" and "%exstyle <st> <val>" set variables like "%set <st> <val>".
+ new cmd: %length <dest-var> <src-var> : get length of the string which is in <src-var>.
+ minimize/restore all program windows when the main window becomes minimized/restored.
+ fixed winkey+d bug : now hide all the program windows.
+ new control: grid.
+ the content window works with listboxes, comboboxes, headers and grids.
+ added variable "i.width" - width of item.
+ the content window can be resized.
+ added new cmd: %replace <what to replace:varname> <what to insert:varname> <where to replace:var_name> : replace a substring.
+ VISG is little tested under ReactOS 0.3.3-RC2 (in qemu). Looks like VISG works properly.
+ Ability to convert backslash in captions.
+ MASM generator is fixed (bug with null/empty strings).
+ All the generators are enhanced (better string convertion).
+ Added new cycle: %for each number <varname> : loop while %varname% > 0.
+ Common script to generate window class names and also control identifiers for all winapi generators.
+ "%include" can take any amount of args (arg0 - name of the file, arg1...argN - arguments).
+ new cmd: %local <var1> <var2> ... <varN> : makes specified variables local.
+ fixed a bug with wrong main menus in the tool windows.

--- 0.92 (September 13 2007)

+ resize the statusbar(s), if any, when the parent window is resizing.
+ new final syntax of visg script language
  (removed "rem", "endif" -> "end if", "endfor" -> "end for", "for each_xxxx" -> "for each xxxx"
   "var_is" -> "==", "var_eq" -> "=", "var_in_var" -> "in",
   also added a dot sign - it allows to use tabs in command lines (see the code for details)).
+ added accelerators: ^T == testmode, ^W == show all windows, ^L == litemode, ^O == open project,
  ^D == direct put, ^C == clone window, ^S == save project.
+ %include cmd supports two arguments now (variables arg1 & arg2).
+ now the key "tab" works in all windows.
+ the property window can be smaller now.
+ new controls: a password editbox, a multiline editbox.
+ modified some default styles of controls (edit, richedit, ...).
+ the program interface works faster now.
+ now you can resize the controls by all its borders.
+ fixed the bug with opening projects which content tab controls.
+ new looking frame around the current control.
+ mark the control which the property window is open for.
+ now you can enter the multiline caption for a control.
+ the key "Del" deletes current control.
+ shift new window from the last window position.
+ fixed: the key navigation in the property window.
+ in the test mode, the close of a window restores the normal mode and doesn't destroy the window.
+ when destroying a window or a control, close its property window, if any.
+ added 3 control flags: needmouse, sendresize, hascaption.
+ fixed opening projects which content richedit.
+ fixed saving projects with multiline captions and captions with ' and " symbols (convert special symbols in captions).
+ added 5 special variables: %NL% == \n, %CR% == \r, %TAB% == \t, %QUO% == \", %APO% = \'
  (these variables are used in "%convert" cmd).
+ new script cmd's: convert, expand and exec.
+ pass the filename to "include" cmd without extension (".vsg" is always used).

--- 0.91 (August 30 2007)

+ now visg is able to check for new updates of the program.
+ autocheck updates (see settings).
+ all the bitmaps have been repainted.
+ F1 shows the "about" dialog.
+ added "examples" plugin (see Help menu).
+ added Gentee generator (www.gentee.com).

--- 0.9 (August 22 2007)

+ fixed the plugin for FreeBASIC. now it can be compiled by the last public version of FBC (0.17)
+ fixed the search for plugins. now variables "typemask" and "typevalue" are used to fix the search.
  it must be set for the different controls of the same class with different style list.
  (because of this bug, VISG shows wrong style list sometimes)
+ show also the alias of control in the popup tooltip.
+ removed unused interface messages.
+ added script cmd "include" to include files into current script (%include "filename").
+ now VISG saves projects as visg script files (see "proj_save.vsg").
+ added new feature: "Clone a window". It clones any visible window on the desktop.
+ added script cmd: "%debug <message> <variable to show>"
+ added script cmd: "%new window|control|item"
+ added: also set "c.alias" in "for each_control" loop.
+ fixed: set alias "ctl" for unknown controls.
+ fixed: show tooltip over STATIC too.
+ added: now the "change" button on the TabControl property window works properly.
+ changed: method of tab switching. now it is a little faster.
+ switch the control focus to the window when that window is clicked.
+ fixed the code generation, if some windows was previously deleted.
+ fixed a bug with getting window text.
+ the code is refactored. visg is a little faster now.
+ added internal function to check integrity of current project.
+ now visg generates also the code for event handling (for buttons, checkboxes).
+ now the "id" editbox in the property window is a combobox.
+ visg generators got more optimal tabs processing.
+ enhanced assembler generators (only script for all supported dialects).
+ now script comments may start just from "% ".
+ added new cmd: "%break <if|for|script> <level>": it breaks execution of a block of commands.
+ added new cmd: "%setex <var> <string with vars>": set the value with conversion.
+ do not put to the code the identifiers which has no references.
+ now you can choose a font for controls and windows.
+ added to "for each_control": set "c.library" variable (name of library which must be loaded for control).
+ added "ctltype" for each control and window. (c.ctltype is available in "for each_control" loop).
+ show ctltype instead of alias in the tooltips.
+ added VISG LiteMode. You can tune it through "litemode.vsg".
+ added cmd: "%if var_in_var <substr_var> <bigstr_var>": find the given substring.
+ fixed the bug with RichEdit control: now visg generates the code to load needed libraries.

--- 0.8 (July 26 2007)

+ fixed delphi generator (wrong use of "@" sign).
+ added new constants "now" and "this_file" to VISG Script language.
+ fixed: create controls according to the grid.
+ added: animate control.
+ added: header control.
+ added: toolbar control.
+ added variable "this_filename" - name of current file without ext.
+ added assembler generators: tasm, masm and lzasm.
+ added list of all features.
+ added separators in the toolwindow.
+ show the count of windows on the toolwindow.
+ show the count of controls on the toolwindow.
+ select just created controls.
+ save toolwindow position in config.
+ resize the last toolwindow button of each group.
+ new feature "direct put": fast create controls on the form without dragging.
+ multilingual toolwindow.
+ added option "tool_width" to change the width of toolbuttons.
+ now a script file can have any length.
+ now you can create your own variables in scripts with any name.
+ save position of main window in the config.
+ option "use winxp style" for VISG program.
+ added service plugin "command line".
+ added brief VISG help (html format).
+ added: monthcal, statusbar, hotkey, listview, datetimepick.
+ added: rebar control (disabled; enable it, if you need it).
+ added: ip-address control (disabled, doesn`t work properly, i don`t know why).
+ added: pager control (disabled; enable it, if you need it).
+ added: native font control (disabled, i don`t know how it works).
+ added: rich edit control.
+ added: variable "load_library": use it, if a control needs an additional library like RichEdit.
+ modified several plugin images to look better.
+ save position of userwindow in the config.
+ show a tooltip for all created controls (show its class, position and size).
+ added an option: show the created program.
+ now property window can be resized.
+ save position and size of property window in the config.
+ added ability to set names for controls (symbolic identifiers).
+ names of controls and windows are available in scripts as "c.name" and "w.name".
+ visg can autogenerate unique names of controls.
+ added to script language: "for each_name", "n.caption", "n.index", "n.count", "w.count", "if any_name_exists".
+ added: "i.count", "c.count".

--- 0.7 (July 08 2007)

+ fixed: hide the frame when the current control is deleted.
+ added: a question msgbox when deleting a window.
+ added: a coding plugin for pascal/delphi.
+ enhanced the generating scripts: do not redraw all the window when tab selecting.
+ added option: "always on top" for main window.
+ save "fast settings" (which are placed on the main window) in the config file.
+ added "view" menu.
+ added tool window (see "view" menu).
+ now all the windows can be moved by mouse dragging within client area.
+ added the "show all windows" button to the toolwindow.
+ added the "main menu" button to the toolwindow.
+ added new controls: updown, treeview, trackbar.
+ "fast settings" is moved from main window to "view" menu and also toolwindow.
+ pre-alpha generator "C, Xlib" (tested under Zenwalk, gcc).
+ modified some icons to be unique.

--- 0.6 (June 29 2007)

+ added a mark in the language menu which shows what is the current language.
+ added more controls: all standard M$Windows controls, plus several common controls.
+ fixed: now the control will be created at the point where the mouse clicked.
+ added new item to the service menu.
+ fixed contextmenu for some controls (like edits).
+ fixed dragging and resizing for some controls.
+ added a frame around the current control.
+ added settings window.
+ added grid settings (grid_dx, grid_dy).
+ fixed: the context menu will be displayed at the mouse cursor when the user presses context menu key.
+ modified: "standard" control resizing by only the mouse instead of with "shift" key.
+ modified destination of "update" service.
+ added: option "disabled" for plugins.
+ added: menuitem "help"/"go to the website".
+ translated plugins.txt to Russian.
+ added "help" plugins (for documentation).
+ added "service" plugins (to call external programs).
+ fixed: no more several property windows for the same control.
+ added: mode for moving/sizing the controls according to the grid.
+ added: test mode.
+ added: license for VISG.

--- 0.5 (June 02 2007)

+ fixed memory leaks.
+ added "control" plugins. now anyone is able to add its own controls.
+ added "window" plugins. it allows to create varied kinds of predefined windows and dialogs.
+ "control" plugins support its own list of styles.
+ added a lot of controls.
+ enhanced user interface.

--- 0.4 (May 09 2007)

+ now visg supports its own script language to translate messages, generate the source code and save/open settings.
+ one more interface language: transliterated russian #2.
+ fixed tab switching for Pascal programming language.

--- 0.3  (Apr 23 2007)

+ better code.
+ added PASCAL programming language.
+ smaller icons (old icons was too big for menus).

--- 0.2  (Apr 19 2007)

+ fixed bug with end-of-line character (now it`s \r\n instead of only \n).
+ better code.
+ save_project support.
+ added EDIT control.
+ added PROGRESS_BAR control.
+ now a window cannot be smaller than its content.
+ open_project support.
+ added TRANSLIT interface language.
+ now C code generator produces full source code for tab control support.
+ added icons for the main menu.

--- 0.1  (Apr 12 2007)

+ first public release.

===

VISG (C) 2007 2008 Alexander G. Karpov a.k.a. mrhx.
http://mrhx.clan.su/   [ru]
http://mrhx.ucoz.com/  [en]
http://mrhx.narod.ru/  [ru-old]

===
